#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
	long long n;
	cin>>n;
    long long a[32010],b[32010],c[100][100];
    for (long long i=0;i<n;i++)
    {
        cin >>a[i];
        b[i] = a[i];
    }
    sort(b,b+n);
    long long t=0;
    long long x2=0,y2=0;
    for (long long i=0;i<n;i++)
    {
        long long x=0;
        if (a[i]!=b[i])
        {
            for (long long j=i;j<n;j++)
            {
                if (a[j]==b[i]) {x=j;break;}
            }
            long long q=x;
            if (x%2==0) x=x/2;
            else x=x/2+1;
            long long r=0;
            for (long long j=i;j<x+1;j++)
            {
                swap(a[j],a[q-r]);
                r++;
            }
            c[t][0]=i;
            c[t][1]=q;
            t++;
        }
    }
    cout <<t<<endl;
    for (long long i=0;i<t;i++)
    {
        cout <<c[i][0]+1<<" "<<c[i][1]+1<<endl;
    }

}
